-- 
-- Please see the license.html file included with this distribution for 
-- attribution and copyright information.
--

     local dropnode = nil;
     local drop_class = nil;
     local drop_id = nil;
     local drop_description = nil;
      
     function onDrop(x, y, draginfo)
       local data = {name=draginfo.getDescription(), attributes={}, text="."};
       drop_description = draginfo.getDescription();
 
       if draginfo.isType("shortcut") then
         drop_class, drop_id = draginfo.getShortcutData();

         -- Interface.dialogMessage("Id "..tostring(drop_id)); 

         -- source = draginfo.getDatabaseNode();
         if drop_class == "power" then
           -- pipp.err();
           --data.name = draginfo.getDescription();
           --data.text = source.createChild("text", "string").getValue();
           --draginfo.reset();
           --draginfo.setType("power");
           --draginfo.setCustomData(data);
           --if super and super.onDrop then
             -- return super.onDrop(x, y, draginfo);
           -- end
         else
           drop_id = nil;
         end
       end
     end
     
     function onListChanged()
       local target = getLastElement();

       if target and drop_description then
         if drop_description then 
           target.name.setValue(drop_description);
           drop_description = nil;
         end
         if drop_class == "referencetext" or drop_class == "referencetextwide" then
           -- do nothing and default to power
         elseif drop_class == "power" then
           target.shortcut.getDatabaseNode().createChild("systems", "string").setValue(nil);
         else
           local class, id = target.shortcut.getValue();  
            
           target.shortcut.setValue(drop_class, id);
         end
       end
     end

     function getLastElement()
       local target = nil;
       local target_id = nil;
       local w_id = nil;
       
       for i, w in ipairs(getWindows()) do
         
         _, w_id = w.shortcut.getValue();

         -- Interface.dialogMessage(tostring(i).." "..tostring(w_id));

         if target_id == nil or w_id > target_id then
           target = w;
           _, target_id = target.shortcut.getValue(); 
         end
       end

         -- Interface.dialogMessage(tostring(target_id));

       return target;
     end
     