-- 
-- Please see the license.html file included with this distribution for 
-- attribution and copyright information.
--

function onInit()
  -- Set the displays to what should be shown
  setTraitVisibility();
end
  
function initValues()
  if name.getValue() and name.getValue() ~= "" then
    label.subwindow.label.setValue(name.getValue());
    name.setValue("");
    bonus.setValue(evaluateBase());
  end
end

function evaluateBase() 
  local char = getDatabaseNode().getParent().getParent();
  local b1, b2;
  local result = 0;

  if not char or not base1 or not base2 then
    return 0;
  end
  b1 = char.getChild(string.lower(base1.getValue()));
  b2 = char.getChild(string.lower(base2.getValue()));
  if base1.getValue() and base1.getValue() ~= "" and b1 then
    result = result + b1.getValue();
  else
    return -1;
  end
  if base2.getValue() and base2.getValue() ~= "" and b2 then
    result = result + b2.getValue();
  else
    return -2;
  end
  return result;
end

--
-- SECTION VISIBILITY FUNCTIONS
--

function setTraitVisibility()
  local v = false;
  if activatetraits.getValue() == 1 then
    v = true;
  end
  
  -- effecticon.setVisible(v);
  
  -- effects.setVisible(v);
  -- effects_iadd.setVisible(v);
  -- for _,w in pairs(effects.getWindows()) do
  --   w.idelete.setValue(0);
  -- end

  traits.setVisible (v);

  summary.setVisible(not v);
  
  summary.onTagsChanged();
end

function onClick(x, y)
  activatetraits.onButtonPressed(); 
end

-- ---------------
-- SKILL FUNCTIONS
-- ---------------

function onDragStart(button, x, y, draginfo)
-- useful?
  if label.getValue() == "" and bonus.getValue() == 0 then
    return nil;
  end

  draginfo.setType("number");
  draginfo.setDescription(label.getValue());
  draginfo.setStringData(label.getValue());
  draginfo.setNumberData(bonus.getValue());
  return true;
end

function onDoubleClick(x, y, label_trait)
  local trait = "";
  local mod = 0;
  if label_trait ~= nil then
    trait = " ["..label_trait.."]";
    -- mod = 30;
  end
  local rRoll = { sType = "dice", 
        sDesc = label.getValue()..trait, 
        aDice = GameSystem.getPercentileDice(),
        nMod = mod}; 
  ActionsManager.performAction(nil, 
    ActorManager.getActor("..", windowlist.window.getDatabaseNode()), 
    rRoll);
  return true;
end

function onDrop(x, y, draginfo)
-- deprecated
  local sDragType = draginfo.getType();
  if sDragType == "dice" then
    local aDropDice = draginfo.getDieList();
    for _,vDie in ipairs(aDropDice) do
      -- dice.addDie(vDie.type);
    end
    return true;
  end
end
