-- 
-- Please see the license.html file included with this distribution for 
-- attribution and copyright information.
--

local node;
local opening;
local opened;

function onInit()
  linkNode()
end

function linkNode()
  node = window.getDatabaseNode();
  
  if node.getChild("..").getPath() == "combattracker.list" and window.link 
      and window.link.getTargetDatabaseNode() then
    node = window.link.getTargetDatabaseNode();
  end
  if not node.isOwner() and window.link 
      and window.link.getTargetDatabaseNode() then
    Debug.console("Warning: not owner, using node or link");
    node = window.link.getTargetDatabaseNode();
  end
  opening = node.createChild("opening", "string");
  opened = node.createChild("opened", "string");
end

function getStrikeRank()
  return 0; 
end

function getNode()
  -- addition of actual link may take place later, check again 
  if not node.getChild("init") then
    linkNode();
  end 
  return node;
end    

function onButtonPress()
  local sr = 0;
  local initresult = node.createChild("initresult", "number");
  
  if self.canAct() then
    return false;
  end
  
  if(window.health and window.health.getValue() < 0 ) then
    sr = sr + window.health.getValue();
  end
  
  if opening and string.len(opening.getValue()) == 0 and self.getStrikeRank() > 0 then
    initresult.setValue(self.getStrikeRank()+sr);
    opening.setValue(self.getOpeningLabel());
    opened.setValue(nil);
    return true;
  elseif opening and opening.getValue() ~= self.getOpeningLabel() and self.getStrikeRank() > 0 then
    opening.setValue(self.getOpeningLabel());
    if initresult.getValue() > 5 then
      initresult.setValue(initresult.getValue()-5);
    else
      initresult.setValue(0);
    end 
    return true;
  else
    return false;
  end
end

function getOpeningLabel()
  return nil; -- pure virtual function
end

function getOpening()
  return opening.getValue();
end

function setOpening(v)
  opening.setValue(v);
end

function hasOpened()
  return string.len(opened.getValue()) > 0;
end

function open(v)
  opened.setValue(v); 
end

function getSrExpenditure()
  return 5;
end

function canAct()
  return false;
end
