-- 
-- Please see the license.html file included with this distribution for 
-- attribution and copyright information.
--

function onListChanged()
  window.windowlist.onListChanged();
end

function update(bEdit)
  for _,wAttribute in ipairs(getWindows()) do
    wAttribute.idelete.setVisibility(bEdit);
  end
end

function addEntry(bFocus)
  local w = createWindow();
  if bFocus then
    w.label.setFocus();
  end
  return w;
end

function onDrop(x, y, draginfo)
  local sDragType = draginfo.getType();
  if sDragType == "number" then
    local w = addEntry(true);
    if w then
      w.label.setValue(draginfo.getDescription());
      w.bonus.setValue(draginfo.getNumberData());
    end
    return true;
  elseif sDragType == "dice" then
    local aDropDice = draginfo.getDieList();
    local w = getWindowAt(x,y);
    if w then
      for _,vDie in ipairs(aDropDice) do
        w.dice.addDie(vDie.type);
      end
    end
    return true;
  end
end
