-- 
-- Please see the license.html file included with this distribution for 
-- attribution and copyright information.
--

function onInit()
end       

function equip(weapon)
  local other, over = findOther(weapon); 

  if over ~= nil and GameSystem.mustBeReadied(weapon.getDatabaseNode()) then
    -- rollback  
    weapon.equipped.setValue(0);
  else
    local opening = window.getDatabaseNode().createChild("opening", "string")
  
    if string.len(opening.getValue()) > 0  then
      -- pay sr and equip
      local sr = window.getDatabaseNode().createChild("initresult", "number");
      local expenditure = 0;
      local msg = Interface.getString("message_equip").." "..weapon.name.getValue();
      
      if weapon.defence_sr.getValue() > 0 then
        expenditure = weapon.defence_sr.getValue();
      else
        expenditure = weapon.attack_sr.getValue();
      end

      --if sr.getValue() < expenditure then
      --  sr.setValue(0);
      --else
      --  sr.setValue(sr.getValue()-expenditure)
      --end
      --msg = msg.." ("..tostring(expenditure).." sr)";
      
      ChatManager.Message(msg,
        not (User.isHost() and OptionsManager.isOption("REVL", "off")), 
        ActorManager.getActorFromCT(window.getDatabaseNode()));
    end

    if other == nil or other.attack_ready.getValue() == 0 
        or other.attack_sr.getValue() < weapon.attack_sr.getValue() then
      if weapon.attack_sr.getValue() > 0 then
        attack_ready(weapon);
      end
    end
    
    if other == nil or other.defence_ready.getValue() == 0 
        or other.defence_sr.getValue() > weapon.defence_sr.getValue() then
      if weapon.defence_sr.getValue() > 0 then
        defence_ready(weapon);
      end
    end
  end
end

function unequip(weapon)
  local opening = window.getDatabaseNode().createChild("opening", "string");
  local other, over = findOther(weapon); 
   
  if string.len(opening.getValue()) > 0 then
    local sr = window.getDatabaseNode().createChild("initresult", "number"); 
    local expenditure = 0;
    local msg = Interface.getString("message_unequip").." "..weapon.name.getValue();
  
    if weapon.defence_sr.getValue() > 0 then
      expenditure = weapon.defence_sr.getValue();
    else
      expenditure = weapon.attack_sr.getValue();
    end

    --if sr.getValue() < expenditure then
    --  sr.setValue(0);
    --else
    --  sr.setValue(sr.getValue()-expenditure)
    --end
    --msg = msg.." ("..tostring(expenditure).." sr)";
    
    ChatManager.Message(msg,
      not (User.isHost() and OptionsManager.isOption("REVL", "off")), 
      ActorManager.getActorFromCT(window.getDatabaseNode()));
  end

  if other ~= nil and other.attack_sr.getValue() > 0 then
    attack_ready(other);
  end
    
  if other ~= nil and other.defence_sr.getValue() > 0 then
    defence_ready(other);
  end
  
end

function findOther(weapon)
  local w1 = nil;
  local w2 = nil;
  
  for _,item in ipairs(getWindows()) do
    if item ~= weapon and item.equipped.getValue() > 0 
        and GameSystem.mustBeReadied(item.getDatabaseNode()) then
      if w1 ~= nil then
        w2 = item;
        return w1, w2;
      else
        w1 = item;
      end
    end
  end
  return w1, w2;
end

function attack_ready(weapon)
  local r = window.getDatabaseNode().createChild("reach", "number"); 

  for _,item in ipairs(getWindows()) do
    if item ~= weapon then
      item.attack_ready.setValue(0);
    end
  end
        
  if weapon then
    weapon.attack_ready.setValue(1);
    r.setValue(weapon.getDatabaseNode().getChild("reach").getValue());
  else
    r.setValue(0);
  end
end

function defence_ready(weapon)
  for _,item in ipairs(getWindows()) do
    if item ~= weapon then
      item.defence_ready.setValue(0);
    end
  end
  if weapon then
    weapon.defence_ready.setValue(1);
  end
end

-- NOTE: Lua sort function expects the opposite boolean value compared to built-in FG sorting
function onSortCompare(w1, w2)
  -- Debug.sortValue(w10);
  return sortValue(w1) < sortValue(w2);
end

function sortValue(node)
  return node.equipped.getValue() * 8 
    + node.attack_ready.getValue() * 4
    + node.defence_ready.getValue() * 2
    + bool_to_number(not GameSystem.mustBeReadied(node.getDatabaseNode()));
end

function bool_to_number(value)
  return value and 1 or 0
end