-- 
-- Please see the license.html file included with this distribution for 
-- attribution and copyright information.
--

function onInit()
end

function onDragStart(button, x, y, dragdata)
  if window.shortcut and not window.shortcut.isEmpty() then
    return loadData(dragdata, window.shortcut);
  elseif window.listlink and not window.listlink.isEmpty() then
    return loadData(dragdata, window.listlink);
  elseif window.link and not window.link.isEmpty() then
    return loadData(dragdata, window.link);
  end

  type = dragdata.getType()

  if type == "shortcut" then
    type, id = dragdata.getShortcutData();
    Debug.console("drag start, class: "..type.." id: "..id);
  else
    Debug.console("drag start, type: "..type);
  end;
  return true;
end

function onClickDown( button, x, y )
  return true;
end

function onClickRelease( button, x, y )
  if window.shortcut and not window.shortcut.isEmpty() then
    return window.shortcut.activate() ~= nil;
  elseif window.listlink and not window.listlink.isEmpty() then
    return window.listlink.activate() ~= nil;
  elseif window.link and not window.link.isEmpty() then
    return window.link.activate() ~= nil;
  end
end

function loadData(dragdata, link)
  local type, id = link.getValue();
  local descr = "link";
  
  dragdata.reset();
  dragdata.setType("shortcut");
  dragdata.setShortcutData(type, id);
  
  local node = DB.findNode(id);
  if node and node.getChild("name") then 
    dragdata.setDescription(node.getChild("name").getValue());
  else
    dragdata.setIcon("button_expand");
  end
  
  return true;
end

function onDragEnd(dragdata)
  local type = dragdata.getType()

  if type == "shortcut" then
    local id; 
    
    type, id = dragdata.getShortcutData();
    Debug.console("drag end, class: "..type.." id: "..id);
  else
    Debug.console("drag end, type: "..type);
  end;
end
