-- 
-- Please see the license.html file included with this distribution for 
-- attribution and copyright information.
--

function getActor()
  local node = window.getDatabaseNode();
  
  return ActorManager.getActorFromCT(node);
end

function onButtonPress()
  if window.opening and window.opening.getValue() == nil then
    if super and super.onButtonPress then
      super.onButtonPress();
    end
    window.opening.setValue(getOpeningValue());
    if window.update then
      window.update()
    end
  else
    action();
  end
end

function getOpeningValue()
  return nil;
end

function action()
  local trait = "";
  local mod = 0;
  local skill = "Roll";
  
  if window.getDatabaseNode().getChild("skill") then 
    skill = window.getDatabaseNode().getChild("skill").getValue();
    if skill == nil or skill:len() == 0 then
      skill = "Roll";
    end
  end
  if window.getDatabaseNode().getChild("trait") then 
    trait = window.getDatabaseNode().getChild("trait").getValue();
    if trait and trait ~= "" then
      trait = " ["..trait.."]";
    else
      trait = "";
    end
    -- mod = 30;
  end
  local rRoll = { sType = "attack", 
        sDesc = skill..trait, 
        aDice = GameSystem.getPercentileDice(), 
        nMod = mod}; 
  AttackManager.performRoll(nil, getActor(), rRoll);
end
