-- 
-- Please see the license.html file included with this distribution for 
-- attribution and copyright information.
--

function onInit()
  onLinkChanged();
	onFactionChanged();
  DB.addHandler(opening.getDatabaseNode().getPath(), "onUpdate", updateDisplay);
end

function onClose()
  DB.removeHandler(opening.getDatabaseNode().getPath(), "onUpdate", updateDisplay);
end

function isOwner()
  return getDatabaseNode().isOwner() or (link.getTargetDatabaseNode() 
    and link.getTargetDatabaseNode().isOwner()); 
end

function updateDisplay()
	local sFaction = friendfoe.getStringValue();
  local bOwned = isOwner();
  local sOpening = opening.getValue();
  local nLevel = windowlist.getLevel();

  if string.len(sOpening) == 0 then
    sOpening = nil;
  end
  if nLevel ~= nil and nLevel ~= 2 then -- and bOwned
    sOpening = "generic"
  end


  generic_opening.setVisible(sOpening == nil or sOpening == "generic");
  generic_opening.setEnabled(bOwned);
  --power_opening.setVisible(sOpening == nil or sOpening == "power");
  --power_opening.setEnabled(bOwned);
  ranged_opening.setVisible(expanded.getValue() > 0 );
  ranged_opening.setEnabled(bOwned);
  melee_opening.setVisible(sOpening == nil or sOpening == "melee" or expanded.getValue() > 0 );
  melee_opening.setEnabled(bOwned);
  action.setVisible(sOpening ~= nil and nLevel == 2 and expanded.getValue() > 0 and sOpening ~= "generic");
  action.setEnabled(bOwned);
  defence.setVisible(sOpening ~= nil and nLevel == 2 and expanded.getValue() > 0);
  defence.setEnabled(bOwned);
  wait.setVisible(sOpening ~= nil and nLevel == 2 and expanded.getValue() > 0);
  wait.setEnabled(bOwned);
  
  target_summary.onTargetsChanged();
	
	if active.getValue() == 1 and level.getValue() ~= 2 then
		name.setFont("sheetlabel");

		active_spacer_top.setVisible(true);
		active_spacer_bottom.setVisible(true);
		
   if sFaction == "friend" then
      setFrame("ctentrybox_friend_active");
    elseif sFaction == "neutral" then
      setFrame("ctentrybox_neutral_active");
    elseif sFaction == "foe" then
      setFrame("ctentrybox_foe_active");
    else
      setFrame("ctentrybox_active");
    end
    
		windowlist.scrollToWindow(self);
		
	else
		name.setFont("sheettext");

		active_spacer_top.setVisible(false);
		active_spacer_bottom.setVisible(false);
		
		if sFaction == "friend" then
			setFrame("ctentrybox_friend");
		elseif sFaction == "neutral" then
			setFrame("ctentrybox_neutral");
		elseif sFaction == "foe" then
			setFrame("ctentrybox_foe");
		else
			setFrame("ctentrybox");
		end
	end
end

function onActiveChanged()
	updateDisplay();
end

function onFactionChanged()
	updateDisplay();
end

function onLinkChanged()
end

-- Rd100

function onDrop(x, y, draginfo)
  if draginfo.isType("shortcut") or draginfo.isType("string")then
    -- trait.setValue(draginfo.getDescription());
    getDatabaseNode().getChild("trait").setValue(draginfo.getDescription());
    return true;
  end
end

function setLevel(level)
  local sFaction = friendfoe.getStringValue();

  initresult.setVisible(level > 0);

  -- wounds.setVisible((level == 2) and (sFaction == "friend"));
  health.setVisible((level == 2) and (sFaction == "friend"));
  condition.setVisible(not health.isVisible());
 
  moving.setVisible(level == 3);
  
  expanded.setValue(0);

  updateDisplay();
end
