-- 
-- Please see the license.html file included with this distribution for 
-- attribution and copyright information.
--

local controls = {};

function onInit()
  local level = 0;

  for _,v in ipairs(self.level_check) do
    if self[v] then 
      table.insert(controls, self[v]);
    end
  end
  setLevel(getDatabaseNode().createChild("level", "number").getValue());
end

function setLevel(level)
  for _,v in ipairs(controls) do
    if v.setLevel then 
      v.setLevel(level)
    elseif v.basic then
      v.setVisible(level > 0)
    elseif v.advanced then
      v.setVisible(level > 1)
    end
    if v.applySort then
      v.applySort();
    end
  end  
  
  -- label_wounds.setVisible(level == 2);
  label_health.setVisible(level == 2);
  label_init.setVisible(level > 0);
  label_moving.setVisible(level == 3);
  
  if host then
    button_global_effects.setVisible(level > 0);
    button_global_spacing.setVisible(level == 2);
    button_global_attacks.setVisible(level > 0);
  end 
end

function getLevel() 
  return getDatabaseNode().getChild("level").getValue();
end