-- 
-- Please see the license.html file included with this distribution for 
-- attribution and copyright information.
--

local node = nil;
local score = nil;
local skill = nil;

function onInit()
  -- make sure a score exists
  score = window.getDatabaseNode().createChild("score", "number");
  skill = window.getDatabaseNode().createChild("skill", "string");
end

function onClose()
  if node then 
    DB.removeHandler(node.getPath(), "onUpdate", onUpdate);
    node = nil;
  end
end

function setNode(dNode)
  onClose();
  node = dNode;
  DB.addHandler(node.getPath(), "onUpdate", onUpdate);
end

function onValueChanged()
end

function onUpdate()
  if node then
    setValue(node.getName());
    skill.setValue("Skill");
    score.setValue(0);
  else
    skill.setValue(nil);
    score.setValue(0);
  end
end

function onDrop(x, y, draginfo)
  if draginfo.isType("string") then
    setValue(draginfo.getDescription());
    onClose();
    return true;
  elseif draginfo.isType("shortcut") then
    setValue(draginfo.getDescription());
    setNode(draginfo.getDatabaseNode());
    return true;
  elseif draginfo.isType("number") then
    if draginfo.getDescription():len() > 0 then
      setValue(draginfo.getDescription());
      onClose();
      return true;
    end
  end
end

