-- 
-- Please see the license.html file included with this distribution for 
-- attribution and copyright information.
--

local updated = false;
local focus = false;

function onInit()
  DB.addHandler(getDatabaseNode().getPath(), "onUpdate", checkHealthLoss);
end

function onClose()
  DB.removeHandler(getDatabaseNode().getPath(), "onUpdate", checkHealthLoss);
end

function checkHealthLoss()
  GameSystem.checkHealthLoss(window.getDatabaseNode());
  if getValue() < 0 then
    setValue(0);
  end
end

function onLoseFocus()
  focus = false;
  if updated then
    checkHealthLoss();
    updated = false;
  end
  DB.addHandler(getDatabaseNode().getPath(), "onUpdate", checkHealthLoss);
end

function onGainFocus()
  focus = true;
  DB.removeHandler(getDatabaseNode().getPath(), "onUpdate", checkHealthLoss);
end

function onDrop(x, y, draginfo)
  local retval = true;
  
  if super and super.onDrop then
    retval = super.onDrop(x, y, draginfo);
  end
  if hasFocus() then
    setFocus(false);
    setFocus(true);
  end
  return retval;
end

function onValueChanged()
  if focus then
    updated = true;
  end
  if super and super.onValueChanged then
    super.onValueChanged();
  end
  window.windowlist.applySort();
end

