-- 
-- Please see the license.html file included with this distribution for 
-- attribution and copyright information.
--

local db_level = nil;

function onInit()
  db_level = window.getDatabaseNode().createChild("level", "number");
  DB.addHandler(db_level.getPath(), "onUpdate", onUpdate);
  OptionsManager.registerCallback("RD100.Other", onUpdate);
  if db_level.getValue() then
    setValue(db_level.getValue());
  else
    DB.setValue(db_level.getPath(), "number", getValue());
  end
  -- setLevel(db_level.getValue());
  onUpdate();
end

function onClose()
  DB.removeHandler(db_level.getPath(), "onUpdate", onUpdate);
  OptionsManager.unregisterCallback("RD100.Other", onUpdate);
end

function onValueChanged()
  DB.setValue(db_level.getPath(), "number", getValue());
  -- onUpdate will trigger setLevel
  -- setLevel(db_level.getValue());
end

function onUpdate()
  local nLevel =  db_level.getValue();
  
  if nLevel == 3 and not OptionsManager.isOption("RD100.Other", "on") then
    nLevel = 0; 
    DB.setValue(db_level.getPath(), "number", nLevel);
  end
  setValue(nLevel);
  setLevel(nLevel);
end

function setLevel(level)
  if level == 0 then
    CombatManager.setCustomSort(sortonrp);
  elseif level == 1 then
    CombatManager.setCustomSort(CombatManager.sortfuncStandard);
  else
    CombatManager.setCustomSort(CombatManager.sortfuncStandard);
  end

  if window.setLevel then
    window.setLevel(level);
  end
end

-- NOTE: Lua sort function expects the opposite boolean value compared to built-in FG sorting
function sortonrp(node1, node2)
  local nValue1 = DB.getValue(node1, "rp", 0);
  local nValue2 = DB.getValue(node2, "rp", 0);
  if nValue1 ~= nValue2 then
    return nValue1 > nValue2;
  end
  
  local sValue1 = DB.getValue(node1, "name", "");
  local sValue2 = DB.getValue(node2, "name", "");
  if sValue1 ~= sValue2 then
    return sValue1 < sValue2;
  end

  return node1.getNodeName() < node2.getNodeName();
end

