-- 
-- Please see the license.html file included with this distribution for 
-- attribution and copyright information.
--

-- extends ct.lua from CoreRPG

-- local enableglobaltoggle = true;
local nLevel;

function onInit()
  super.onInit();
  if window.getDatabaseNode().createChild("level", "number").getValue() == nil then
    window.getDatabaseNode().getChild("level").setValue(0);
  end
  setLevel(window.getDatabaseNode().getChild("level").getValue());
end

-- extend CoreRPG
function addEntry(bFocus)
  local w = super.addEntry(bFocus);
  
  if w then 
    w.setLevel(window.getDatabaseNode().getChild("level").getValue());
    w.opening.setValue("");
  end 
  return w;
end

-- extend CoreRPG
function onEntrySectionToggle()
  local anyActive = 0;

  super.onEntrySectionToggle();
  for _,v in pairs(getWindows()) do
    if v.activateattacks.getValue() == 1 then
      anyActive = 1;
    end
  end

  super.enableglobaltoggle = false;
  window.button_global_attacks.setValue(anyActive);
  super.enableglobaltoggle = true;
end

-- extend CoreRPG
function onDrop(x, y, draginfo)
  local result = super.onDrop(x, y, draginfo);
   
  if result then 
    setLevel(window.getDatabaseNode().getChild("level").getValue());
  end
  return result;
end

function toggleAttacks()
  if not enableglobaltoggle then
    return;
  end
  
  local attackson = window.button_global_attacks.getValue();
  for _,v in pairs(getWindows()) do
    if attackson ~= v.activateattacks.getValue() then
      v.activateattacks.setValue(attackson);
    end
  end
end

function setLevel(level)
  if level == nil then
    level = 0;
  end
  nLevel = level;
  
  for _,v in ipairs(getWindows()) do
    if v.setLevel then 
      v.setLevel(level)
    end
  end
end

function getLevel()
  return nLevel;
end

function onListChanged()
  setLevel(nLevel);
end