-- 
-- Please see the license.html file included with this distribution for 
-- attribution and copyright information.
--

function onDragStart(button, x, y, dragdata)
  if window.listlink then
    return loadData(dragdata, window.listlink);
  elseif window.link then
    return loadData(dragdata, window.link);
  end

  type = dragdata.getType()

  if type == "shortcut" then
    type, id = dragdata.getShortcutData();
    Debug.console("drag start, class: "..type.." id: "..id);
  else
    Debug.console("drag start, type: "..type);
  end;
  return true;
end

function loadData(dragdata, link)
  local type, id = link.getValue();
  
  dragdata.reset();
  dragdata.setType("shortcut");
  dragdata.setShortcutData(type, id);
  dragdata.setIcon("button_expand");
  return true;
end

function onDragEnd(dragdata)
  local type = dragdata.getType()

  if type == "shortcut" then
    local id; 
    
    type, id = dragdata.getShortcutData();
    Debug.console("drag end, class: "..type.." id: "..id);
  else
    Debug.console("drag end, type: "..type);
  end;
  -- pipp.error();
end
