-- 
-- Please see the license.html file included with this distribution for 
-- attribution and copyright information.
--

-- Ruleset action types
actions = {
	["dice"] = { bUseModStack = "true" },
	["table"] = { },
	["effect"] = { sIcon = "action_effect", sTargeting = "all" },
	["attack"] =  { bUseModStack = "true", sTargeting = "all" }
};

targetactions = {
	"effect",
  "attack",
};

function getCharSelectDetailHost(nodeChar)
	return "";
end

function requestCharSelectDetailClient()
	return "name";
end

function receiveCharSelectDetailClient(vDetails)
	return vDetails, "";
end

function getCharSelectDetailLocal(nodeLocal)
	return DB.getValue(nodeLocal, "name", ""), "";
end

function getDistanceUnitsPerGrid()
	return 1;
end

function getRangeNumberFromLevel(rangestr)
  if rangestr == "C" then
    return 20;
  elseif rangestr == "S" then
    return 50;
  elseif rangestr == "M" then
    return 200;
  elseif rangestr == "L" then
    return 500;
  elseif rangestr == "XL" then 
    return 2000;
  elseif rangestr == "XXL" then  
    return 5000;
  elseif rangestr == "XXXL" then  
    return 10000;
  else
    return 0;
  end
end

function getRangeLevelFromNumber(rangeval)
  if rangeval < 10 then
    return "";
  elseif rangeval < 31 then
    return "C";
  elseif rangeval < 81 then
    return "S";
  elseif rangeval < 301 then
    return "M";
  elseif rangeval < 1000 then
    return "L";
  elseif rangeval < 3000 then
    return "XL";
  elseif rangeval < 8000 then
    return "XXL";
  else
    return "XXXL";
  end
end

function standard(score)
  if score > 0 then 
    return score;
  else
    return 10;
  end
end

function modifier(score)
  if score > 0 then 
    return math.modf((standard(score)-3)/5)-1;
  else
    return 0;
  end
end

function evaluateAttributes(node)
  local char = node.getChildren();
  
  if char.might then
    char.might.setValue((char.size.getValue()-3)*2 
      +modifier(char.str.getValue()));
  end
  if char.reflexes then
    char.reflexes.setValue(modifier(char.dex.getValue()));
  end
  if char.toughness then
    char.toughness.setValue(char.size.getValue()*2
      +modifier(char.str.getValue())+modifier(char.con.getValue()));
  end
  if char.combat then
    char.combat.setValue(math.ceil(
        standard(char.dex.getValue()+standard(char.con.getValue())) / 2 ));
  end
  if char.init then
    char.init.setValue(math.ceil(
      standard(char.dex.getValue()+standard(char.str.getValue())) / 2 ));
  end
  -- char.init.setValue(10+modifier(char.str.getValue()));
  if char.basehealth then
    char.basehealth.setValue(char.con.getValue()+char.wil.getValue());
    char.health = char.basehealth;
  end
end

function checkHealthLoss(node)
  if node.getChild("initresult").getValue() < node.getChild("enc").getValue() then
    node.getChild("health").setValue(node.getChild("health").getValue()-1);
  end;
  if node.getChild("initresult").getValue() < 0 then
    node.getChild("initresult").setValue(0);
  end;
end

function readiness(node)
  local char = node.getChildren();
  
  return 15 + modifier(char.dex.getValue());
end

function getPercentileDice()
  if Interface.getVersion() >= 4 then
    return {"d100"};
  else
    return {"d100", "d10"};
  end 
end

function mustBeReadied(node)
  local wpn = node.getChildren();
  
  if not wpn or not wpn.type then 
    return false;
  end 
  
  local type = wpn.type.getValue();
  local weight = wpn.weight.getValue();
  
  return not (type == "Natural" or ((type == "Energy" or type == "") and weight == 0));
end

function isRanged(sType)
  return sType == "Thrown" or sType == "Projectile" or sType == "Energy";
end