-- 
-- Please see the license.html file included with this distribution for 
-- attribution and copyright information.
--

function getTraitString(skill)
	-- Start with an empty trait list string
	local aOutputEffects = {};
	
	-- Iterate through each trait
	local aSorted = {};
	for _,nodeChild in pairs(DB.getChildren(skill, "traits")) do
		table.insert(aSorted, nodeChild);
	end
	table.sort(aSorted, function (a, b) return a.getName() < b.getName() end);
	for _,v in pairs(aSorted) do
		local sLabel = DB.getValue(v, "name", "");

  	if string.len(sLabel) > 0 then 
  	  table.insert(aOutputEffects, sLabel);
  	end
	end
	
	-- Return the final effect list string
	return table.concat(aOutputEffects, ", ");
end

